/*=============================================================
　FIX型 電子書籍作成支援：2列の表組からブックマークを作成するスクリプト
===============================================================
● 右列の数値（ノンブル）に前付のページ数を加算し、InDsignのページ番号に揃える
● 空セル、タイトルセル内の改行、右側セルの数値以外文字をエラー表示
● ブックマークを作成（全てレベル１、入れ子は非対応）

配布・改変は自由ですが、販売は禁止します。
本スクリプトに基づいて被ったいかなる損害について、一切責任を負うものではございません。
不具合等が生じてもサポートは一切致しません。
利用した時点で上記に同意したとみなします。

動作確認　InDesign 2022~2023
2023/02/28 Copyright もの書き屋のしっぽ
===============================================================*/
#target InDesign 

main();
//エラー処理
function myerror(mess){
	if (arguments.length > 0){
		alert(mess);
		}
	exit();
}

function main(){
var doc=app.activeDocument;
	if(doc.selection>-1){
		myerror("表を含むテキストフレームを選択して下さい");
	}
	if (doc.selection[0].constructor.name=="InsertionPoint"){
		myerror("表を含むテキストフレームを選択して下さい");
	}
	if(doc.selection[0].constructor.name != "TextFrame"){
		myerror("表を含むテキストフレームを選択して下さい");
	} 

var mytab=app.selection[0].tables.firstItem();

/////表の背景を紙色にする////
var Pcolor=app.activeDocument.swatches.itemByName("Paper");//デフォルト色
var rmvCells= mytab.cells.everyItem();
rmvCells.fillColor=Pcolor;

/////セルのエラーチェック////
var ErColor=app.activeDocument.swatches[6];//エラーマーカー スウォッチの上から6番目、Y100を指定
	for( i=0; i<mytab.rows.length; i++){
		var checkcell_1=mytab.rows[i].cells[0];
		var text=checkcell_1.contents;
		var src1=text.match(/.*[\r\n].*/); //改行をエラーとする
			if(!text){
				checkcell_1.fillColor=ErColor; //空セルならエラー
			}
				if(text==src1){
					checkcell_1.fillColor=ErColor;  //エラー箇所を黄色に
				}
	}
	for( i=0; i<mytab.rows.length; i++){
		var checkcell_2=mytab.rows[i].cells[1];
		var ntext=checkcell_2.contents;
		var src2=ntext.match(/\d*[^0-9^\r^\n]+\d*/); //数字以外と改行をエラーとする
			if(!ntext){
				checkcell_2.fillColor=ErColor; //空セルならエラー
			}
				if(ntext==src2){
					checkcell_2.fillColor=ErColor;  //エラー箇所を黄色に
				}
	}
	for( i=0; i<mytab.rows.length; i++){
		for( a=0; a<mytab.rows[i].columns.length; a++){
			var checkcell=mytab.rows[i].cells[a];
				if(checkcell.fillColor==ErColor){
					alert("Error"+"\n空のセル、改行\nノンブルに数値以外の文字\nのどれかが含まれています");
					exit(); 
				}else{
						//何もしない
					}
		}
	}
////前付けページ数を加算
Frtpage=prompt("前付のページ数を入れてOKを押してください\n見出しが多いと数秒かかります",0);
	var doc=app.activeDocument;
	if (Frtpage!==null){
		if(Frtpage>=0){
			for(i=0; i<mytab.rows.length; i++){
				var Pcell=mytab.rows[i].cells[1];
				var Pcnt=Pcell.contents;
				Pnum=parseInt(Pcnt)+parseInt(Frtpage);
				var GetName=mytab.rows[i].cells[0].contents;
				var page = doc.pages.everyItem().getElements()[Pnum-1];
////ブックマークを作成
				var hp=doc.hyperlinkPageDestinations.add(page,{name:GetName});
				var bm=doc.bookmarks.add(hp);
			}
		app.activeDocument.textFrames.everyItem().remove();    //テキストフレームを削除
		alert("ブックマークを作成しました\nパネルを開いて確認して下さい")
		}else{
		alert("キャンセルしました");
		exit();}
	}

}